"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Injectable = void 0;
const awilix_1 = require("awilix");
const container_1 = require("../container");
const awilix = require('awilix');
/**
 * Marks a class as Injectable.
 * This means that the class's instance can be injected into constructors of other classes through DI.
 * @param registrationName Name to be used while resolving the dependency.
 * During constructor resolution, this name should match the parameter name, or else the `injection` process wouldn't work.
 */
function Injectable(registrationName) {
    return function (constructor) {
        container_1.ControllersContainer.set(registrationName, constructor, awilix_1.Lifetime.TRANSIENT);
    };
}
exports.Injectable = Injectable;
